program = Date

$(program): main.o $(program).o .gitignore
	g++ main.o $(program).o -o $(program)

main.o: main.s
	g++ -c main.s -o main.o

main.s: main.ii
	g++ -S main.ii -o main.s

main.ii: main.cpp $(program).hpp
	g++ -E main.cpp -o main.ii

$(program).o: $(program).s
	g++ -c $(program).s -o $(program).o

$(program).s: $(program).ii
	g++ -S $(program).ii -o $(program).s

$(program).ii: $(program).cpp $(program).hpp
	g++ -E $(program).cpp -o $(program).ii

.gitignore:
	echo $(program) > .gitignore

clean:
	rm -f *.ii *.s *.o .gitignore $(program)

test: $(program)
	./$(program)

